Attribute VB_Name = "ModuleMain"
'***********************Constant Declaration*********************
' Define the sub SID Authority byte arrays.  These arrays are here for completeness along with
' their VC definitions.
'
'#define SECURITY_NULL_SID_AUTHORITY       {0,0,0,0,0,0}
'#define SECURITY_WORLD_SID_AUTHORITY      {0,0,0,0,0,1}
'#define SECURITY_LOCAL_SID_AUTHORITY      {0,0,0,0,0,2}
'#define SECURITY_CREATOR_SID_AUTHORITY    {0,0,0,0,0,3}
'#define SECURITY_NON_UNIQUE_AUTHORITY     {0,0,0,0,0,4}
'
' C Declaration for the SID memory, included for completeness...
'
'typedef struct _SID {
'  BYTE  Revision;
'  BYTE  SubAuthorityCount;
'   SID_IDENTIFIER_AUTHORITY IdentifierAuthority;
'  DWORD SubAuthority[ANYSIZE_ARRAY];
'} SID;
'typedef PVOID PSID;
'***************End Constant Declaration******************************

'**********************************************************************************
'
' Declare the APIs needed to manipulate the RAW SID
'
Private Declare Function InitializeSid Lib "advapi32.dll" (ByVal Sid As Long, _
                                                          pIndentifierAuthority As Any, _
                                                          ByVal nSubAuthorityCount As Byte) As Long
                                                          
Private Declare Function GetSidSubAuthority Lib "advapi32.dll" (pSid As Any, _
                                                               ByVal nSubAuthority As Long) As Long
                                                               
Private Declare Function GetSidLengthRequired Lib "advapi32.dll" (ByVal nSubAuthorityCount As Byte) As Long

Private Declare Function LookupAccountSid Lib "advapi32.dll" Alias "LookupAccountSidA" _
                                        (ByVal lpSystemName As String, _
                                         Sid As Any, _
                                         ByVal name As String, _
                                         cbName As Long, _
                                         ByVal ReferencedDomainName As String, _
                                         cbReferencedDomainName As Long, _
                                         peUse As Integer) As Long
                                         
Private Declare Function GetSidSubAuthorityCount Lib "advapi32.dll" (pSid As Any) As Long

Private Declare Function GetSidIdentifierAuthority Lib "advapi32.dll" (pSid As Any) As Long
'
' Declare the memory managment functions.
' Notice there are two definitions for RtlMoveMemory, one takes a value as  Any, the other takes a value ByVal as long
' this is necessary so memory can be copied as follows:
'  From a variable containing a 32 bit value that represents a memory location
'  From a variable that represents a VB alocated memory location
'  (ie: Dim bByte(6) as Byte type of declaration).
'
' LocalAlloc and LocalFree are used to allocate and free memory from the heap,
' respectively.
'
Private Declare Sub CopyByValMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, _
                                                                         ByVal Source As Long, _
                                                                         ByVal Length As Long)
                                                                         
Private Declare Sub CopyByRefMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, _
                                                                         Source As Any, _
                                                                         ByVal Length As Long)
                                                                         
Private Declare Function LocalAlloc Lib "kernel32" (ByVal wFlags As Long, _
                                                   ByVal wBytes As Long) As Long
                                                   
Private Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long

'************API Function Declarations*************************************
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
' Declare the necessary Win32 APIs to obtain the SID for the NT user
' LookupAccountName -> Does the real work once it is remoted to the appropriated DC
' NetGetDcName -> Obtains the DC for the local box, used to obtain a DC name for
'                 LookUpAccountName
' NetApiBufferFree-> used to cleanup after NetGetDcName.  The Net* APIs manage memory
'                    memory for you, this function is used to free the memory allocated
'                    NetGetDcName
' lstrcpyW -> used to copy the NetGetDcName buffer into a buffer VB can work with
' GetLengthSid -> used to help convert the raw SID into a hexstring SID
'
Private Declare Function LookupAccountName Lib "advapi32.dll" _
        Alias "LookupAccountNameA" _
        (ByVal IpSystemName As String, _
         ByVal IpAccountName As String, _
         pSid As Byte, _
         cbSid As Long, _
         ByVal ReferencedDomainName As String, _
         cbReferencedDomainName As Long, _
         peUse As Integer) As Long
         
Private Declare Function NetGetDCName Lib "netapi32.dll" _
        (servername As Byte, _
         DomainName As Byte, _
         DCNPtr As Long) As Long
                                         
Private Declare Function NetApiBufferFree Lib "netapi32.dll" _
        (ByVal Ptr As Long) As Long
         
Private Declare Function PtrToStr Lib "kernel32" _
        Alias "lstrcpyW" (RetVal As Byte, ByVal Ptr As Long) As Long
       
Private Declare Function GetLengthSid Lib "advapi32.dll" _
        (pSid As Byte) As Long

'************Ulr Loader on this program api*************************
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
                        (ByVal hWnd As Long, _
                         ByVal lpszOp As String, _
                         ByVal lpszFile As String, _
                         ByVal lpszParams As String, _
                         ByVal lpszDir As String, _
                         ByVal FsShowCmd As Long) As Long

Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" _
                        (ByVal lpBuffer As String, _
                         nSize As Long) As Long
'Get User Names
Private Declare Function NetUserEnum Lib "netapi32" (ByVal servername As Long, ByVal level As Long, ByVal filter As Long, buf As Any, ByVal prefmaxlen As Long, entriesread As Long, totalentries As Long, resume_handle As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy&)
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
Private Type NAME_INFO
    name As Long
End Type

'************End API Function Declarations**************************

Sub Main()

Const GroupsName As String = "Dialup|Network|Batch|Interactive|System|Local Service|Network Service|Users|Guests|Power Users|Account Operators|Domain Admins|Domain Users|Domain Guests|Domain Computers"
Const ChrCommand As String = "|"
Dim CBS          As String
Dim CBSNull      As String
        CBSNull = Convert_BIN_To_SDDL("", Space(1))
Dim strUsers()   As String
        Call GetUserNames("", strUsers)
Dim lstrUsers    As String
        For ISum = 1 To UBound(strUsers)
            lstrUsers = lstrUsers & ChrCommand & strUsers(ISum)
        Next ISum
Dim MemoGN()     As String
         MemoGN = Split(GroupsName & lstrUsers, ChrCommand)
         
    StrReport0$ = "User or Group" & vbCrLf & String(30, "-") & vbCrLf
    StrReport1$ = "SID" & vbCrLf & String(60, "-") & vbCrLf
    
    For ISumeSpl = 0 To UBound(MemoGN)
        CBS = Convert_BIN_To_SDDL("", CStr(MemoGN(ISumeSpl)))
        If Not StrComp(CBS, CBSNull) = 0 Then
            StrReport0$ = StrReport0$ & CStr(MemoGN(ISumeSpl)) & vbCrLf
            StrReport1$ = StrReport1$ & CBS & vbCrLf
        End If
    Next
    Erase MemoGN
    
    StrReport0$ = StrReport0$ & String(30, "-")
    StrReport1$ = StrReport1$ & String(60, "-")
    
    Load FrmMain
    With FrmMain
        .LabReport(0).Caption = StrReport0$
        .LabReport(1).Caption = StrReport1$
        
        .LabReport(0).Move 90, 120
        .LabReport(1).Move .LabReport(0).Left + .LabReport(0).Width + 90, 120

        .LabelURL(0).Move .LabReport(0).Left, _
                          .LabReport(0).Top + .LabReport(0).Height + .LabelURL(1).Height
        .LabelURL(1).Move .LabReport(1).Left, _
                          .LabReport(1).Top + .LabReport(1).Height
        
        .Height = .LabelURL(0).Top + .LabelURL(0).Height * 2 + 90
        .Width = .LabReport(1).Left + .LabReport(1).Width + 270
        .Show
    End With
    
End Sub
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' Convert_BIN_To_SDDL takes two arguments: strNTDomain-> The NT domain for the user's account
'                                          strNTAccount-> The NT SAM account name for the user
' The function returns the SDDL form of the user's SID,
'
Private Function Convert_BIN_To_SDDL(strNTDomain As String, strNTAccount As String) As String ' pSid As pSid, pszSidText)
    Dim SDDL_SID As String
    Dim pSia As Long
    Dim pSiaByte(5) As Byte
    Dim pSid(512) As Byte
    Dim pSubAuthorityCount As Long
    Dim bSubAuthorityCount As Byte
    Dim pAuthority As Long
    Dim dAuthority As Double
    Dim lAuthority As Long
    '
    ' Get the SID for the user's account, targetting a local PDC
    '
    IReturn = LookupAccountName(Get_Primary_DCName("", strNTDomain), strNTAccount, pSid(0), 512, pDomain, 512, 1)
    '
    ' Convert the raw sid into its SDDL form ( S-?-?-???-?????? )
    ' The first item in the S- format is the revision level.  If we look closely at the
    ' SID structure in the WinNT.H C Header, we find that the revision value for the SID is
    ' stored in the 0th byte to the raw sid.
    '
    ' Another interesting fact is that the last byte of the Identifying authority structure contains
    ' the second component of the SDDL form, so lets retrieve both of those and
    ' place them into the string.
    '
    pSia = GetSidIdentifierAuthority(pSid(0))
    '
    ' The GetSidIdentifierAuthority returns a pointer to the Identifying Authority structure
    ' The pointer must be copied into some memory that VB knows how to manage, so....
    '
    CopyByValMemory pSiaByte(0), pSia, 6
    SDDL_SID = "S-" + LTrim(Str(pSid(0))) + "-" + LTrim(Str(pSiaByte(5)))    '
    '
    ' The rest of the SDDL form contains a list of sub authorities separated by
    ' "-"s.  The total number of these authorities can be obtained by
    ' calling the GetSidSubAuthorityCount.  The value returned is a pointer into the
    ' SID memory that contains the Sub Authority value, once again, this memory
    ' must be copied into something that VB knows how to manage.
    '
    ' Notice that only 1 byte is copied.  This is because the sub authority count
    ' is stored in a single byte ( see the SID srtructure definition above )
    '
    pSubAuthorityCount = GetSidSubAuthorityCount(pSid(0))
    CopyByValMemory bSubAuthorityCount, pSubAuthorityCount, 1
    '
    ' We can loop throught the sub authorities and convert
    ' their DWORD values to VB longs, then convert them to a
    ' string.
    ' The count is 0 based, so we start at 0 and goto the
    ' number of sub authorities - 1
    '
    For AuthCount = 0 To bSubAuthorityCount - 1
      pAuthority = GetSidSubAuthority(pSid(0), AuthCount)
      CopyByValMemory lAuthority, pAuthority, LenB(lAuthority)
      '
      ' VB does not have an unsigned type, the sub authority value
      ' could have the most significant bit set.  If it is set,
      ' the Str function will return a negative number.  Therefore
      ' we must account for this case by converting the value to
      ' a double then to its string form
      '
      ' Step 1: Test the bit if set, Do step 2 and 3 else put
      ' the value in the output string.
      ' Step 2: 1 is true, so, AND off all the bits save the most
      '   significant bit, place in a temp double variable
      ' Step 3: Add the most significant bit to the double variable ( 2^31)
      ' Output the string
      '
      ' Step 1:
      '
      dAuthority = lAuthority
      If ((lAuthority And &H80000000) <> 0) Then
         '
         ' Bit is set, Step 2:
         '
         dAuthority = lAuthority & &H7FFFFFFF
         '
         ' Step 3:
         '
         dAuthority = dAuthority + 2 ^ 31
      End If
      SDDL_SID = SDDL_SID + "-" + LTrim(Str(dAuthority))
    Next AuthCount
    '
    ' We are done, the SDDL_SID variable contains the SID in
    ' SDDL form,
    ' Return it...
    '
    Convert_BIN_To_SDDL = SDDL_SID
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Get_Primary_DCName -- gets the name of the Primary Domain Controller for
''                       the NT domain
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Get_Primary_DCName(ByVal MName As String, ByVal DName As String) As String

Dim Result As Long
Dim DCName As String
Dim DCNPtr As Long
Dim DNArray() As Byte
Dim MNArray() As Byte
Dim DCNArray(100) As Byte

    MNArray = MName & vbNullChar
    DNArray = DName & vbNullChar
    Result = NetGetDCName(MNArray(0), DNArray(0), DCNPtr)
    If Result <> 0 Then
        Exit Function
    End If
    Result = PtrToStr(DCNArray(0), DCNPtr)
    Result = NetApiBufferFree(DCNPtr)
    DCName = DCNArray()
    Get_Primary_DCName = DCName
    
End Function
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Convert_ObjectSID_To_SDDL converts the objectSID property of a user
'' into the SDDL form of the SID.
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'SID string     Constant in sddl.h                  Account alias
'____________________________________________________________________________________________
'"AO"           SDDL_ACCOUNT_OPERATORS              Account operators
'"RU"           SDDL_ALIAS_PREW2KCOMPACC            Alias to allow previous Windows 2000
'"AN"           SDDL_ANONYMOUS Anonymous            logon
'"AU"           SDDL_AUTHENTICATED_USERS            Authenticated users
'"BA"           SDDL_BUILTIN_ADMINISTRATORS         Built-in administrators
'"BG"           SDDL_BUILTIN_GUESTS Built-in        guests
'"BO"           SDDL_BACKUP_OPERATORS Backup        operators
'"BU"           SDDL_BUILTIN_USERS Built-in         users
'"CA"           SDDL_CERT_SERV_ADMINISTRATORS       Certificate server administrators
'"CG"           SDDL_CREATOR_GROUP Creator          group
'"CO"           SDDL_CREATOR_OWNER Creator          owner
'"DA"           SDDL_DOMAIN_ADMINISTRATORS          Domain administrators
'"DC"           SDDL_DOMAIN_COMPUTERS               Domain computers
'"DD"           SDDL_DOMAIN_DOMAIN_CONTROLLERS      Domain controllers
'"DG"           SDDL_DOMAIN_GUESTS                  Domain guests
'"DU"           SDDL_DOMAIN_USERS                   Domain users
'"EA"           SDDL_ENTERPRISE_ADMINS              Enterprise administrators
'"ED"           SDDL_ENTERPRISE_DOMAIN_CONTROLLERS  Enterprise domain controllers
'"WD"           SDDL_EVERYONE                       Everyone
'"PA"           SDDL_GROUP_POLICY_ADMINS            Group Policy administrators
'"IU"           SDDL_INTERACTIVE Interactively      logged-on user
'"LA"           SDDL_LOCAL_ADMIN Local              administrator
'"LG"           SDDL_LOCAL_GUEST Local              guest
'"LS"           SDDL_LOCAL_SERVICE                  Local service account
'"SY"           SDDL_LOCAL_SYSTEM                   Local system
'"NU"           SDDL_NETWORK                        Network logon user
'"NO"           SDDL_NETWORK_CONFIGURATION_OPS      Network configuration operators
'"NS"           SDDL_NETWORK_SERVICE                Network service account
'"PO"           SDDL_PRINTER_OPERATORS              Printer operators
'"PS"           SDDL_PERSONAL_SELF                  Personal self
'"PU"           SDDL_POWER_USERS                    Power users
'"RS"           SDDL_RAS_SERVERS                    RAS servers group
'"RD"           SDDL_REMOTE_DESKTOP                 Terminal server users
'"RE"           SDDL_REPLICATOR                     Replicator
'"RC"           SDDL_RESTRICTED_CODE                Restricted code
'"SA"           SDDL_SCHEMA_ADMINISTRATORS          Schema administrators
'"SO"           SDDL_SERVER_OPERATORS               Server operators
'"SU"           SDDL_SERVICE                        Service logon user
'_______________________________________________________________________________________
Private Function Convert_ObjectSID_To_SDDL(obj As Variant) As String
    Dim SDDL_SID As String
    Dim pSia As Long
    Dim pSiaByte(5) As Byte
    Dim pSid(512) As Byte
    Dim pSubAuthorityCount As Long
    Dim bSubAuthorityCount As Byte
    Dim pAuthority As Long
    Dim lAuthority As Long
    Dim dAuthority As Double
    Dim cbpSid As Long
    '
    ' Move the obj array into a byte array to work with the raw SID
    ' Not sure why we need to do this, but if we use the variant passed
    ' as the argument, the GetSidSubAuthorityCount API does not return a valid
    ' address... Curious... It might be a typing issue, the obj property is
    ' defined as a variant array of bytes were as the pSid array is defined as
    ' an array of bytes.
    '
    cbpSid = 0
    For i = LBound(obj) To UBound(obj)
       pSid(cbpSid) = obj(i)
       cbpSid = cbpSid + 1
    Next i
    '
    ' Convert the raw sid into its SDDL form ( S-?-?-???-?????? )
    ' The first item in the S- format is the revision level.  If we look closely at the
    ' SID structure in the WinNT.H C Header, we find that the revision value for the SID is
    ' stored in the 0th byte to the raw sid.
    '
    ' Another interesting fact is that the last byte of the Identifying authority structure contains
    ' the second component of the SDDL form, so lets retrieve both of those and
    ' place them into the string.
    '
    pSia = GetSidIdentifierAuthority(pSid(0))
    '
    ' The GetSidIdentifierAuthority returns a pointer to the Identifying Authority structure
    ' The pointer must be copied into some memory that VB knows how to manage, so....
    '
    CopyByValMemory pSiaByte(0), pSia, 6
    SDDL_SID = "S-" + LTrim(Str(pSid(0))) + "-" + LTrim(Str(pSiaByte(5)))
    '
    ' The rest of the SDDL form contains a list of sub authorities separated by
    ' "-"s.  The total number of these authorities can be obtained by
    ' calling the GetSidSubAuthorityCount.  The value returned is a pointer into the
    ' SID memory that contains the Sub Authority value, once again, this memory
    ' must be copied into something that VB knows how to manage.
    '
    ' Notice that only 1 byte is copied.  This is because the sub authority count
    ' is stored in a single byte ( see the SID srtructure definition above )
    '
    pSubAuthorityCount = GetSidSubAuthorityCount(pSid(0))
    CopyByValMemory bSubAuthorityCount, pSubAuthorityCount, 1
    '
    ' We can loop throught the sub authorities and convert
    ' their DWORD values to VB longs, then convert them to a
    ' string.
    ' The count is 0 based, so we start a 0 and goto the
    ' number of sub authorities - 1
    '
    For AuthCount = 0 To bSubAuthorityCount - 1
      pAuthority = GetSidSubAuthority(pSid(0), AuthCount)
      CopyByValMemory lAuthority, pAuthority, LenB(lAuthority)
      '
      ' VB does not have an unsigned type, the sub authority value
      ' could have the most significant bit set.  If it is set,
      ' the Str function will return a negative number.  Therefore
      ' we must account for this case by converting the value to
      ' a double then to its string form
      '
      ' Step 1: Test the bit if set, Do step 2 and 3 else put
      ' the value in the output string.
      ' Step 2: 1 is true, so, AND off all the bits save the most
      '   significant bit, place in a temp double variable
      ' Step 3: Add the most significant bit to the double variable ( 2^31)
      ' Output the string
      '
      ' Step 1:
      '
      dAuthority = lAuthority
      If ((lAuthority And &H80000000) <> 0) Then
         '
         ' Bit is set, Step 2:
         '
         dAuthority = lAuthority & &H7FFFFFFF
         '
         ' Step 3:
         '
         dAuthority = dAuthority + 2 ^ 31
      End If
      SDDL_SID = SDDL_SID + "-" + LTrim(Str(dAuthority))
    Next AuthCount
    '
    ' We are done, the SDDL_SID variable contains the SID in
    ' SDDL form,
    ' Return it...
    '
    Convert_ObjectSID_To_SDDL = SDDL_SID
    '
End Function
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' Local_Convert_BIN_To_SDDL takes two arguments: strNTDomain-> Netbios name for the NT machine to
'                                                              Request account information from
'                                          strNTAccount-> The NT SAM account name for the user
' The function returns the SDDL form of the user's SID,
'
Private Function Local_Convert_BIN_To_SDDL(strNTDomain As String, strNTAccount As String) As String ' pSid As pSid, pszSidText)
    Dim SDDL_SID As String
    Dim pSia As Long
    Dim pSiaByte(5) As Byte
    Dim pSid(512) As Byte
    Dim pSubAuthorityCount As Long
    Dim bSubAuthorityCount As Byte
    Dim pAuthority As Long
    Dim lAuthority As Long
    Dim dAuthority As Double
    '
    ' Get the SID for the user's account, targetting a local PDC
    '
    IReturn = LookupAccountName(strNTDomain, strNTAccount, pSid(0), 512, pDomain, 512, 1)
    '
    ' Convert the raw sid into its SDDL form ( S-?-?-???-?????? )
    ' The first item in the S- format is the revision level.  If we look closely at the
    ' SID structure in the WinNT.H C Header, we find that the revision value for the SID is
    ' stored in the 0th byte to the raw sid.
    '
    ' Another interesting fact is that the last byte of the Identifying authority structure contains
    ' the second component of the SDDL form, so lets retrieve both of those and
    ' place them into the string.
    '
    pSia = GetSidIdentifierAuthority(pSid(0))
    '
    ' The GetSidIdentifierAuthority returns a pointer to the Identifying Authority structure
    ' The pointer must be copied into some memory that VB knows how to manage, so....
    '
    CopyByValMemory pSiaByte(0), pSia, 6
    SDDL_SID = "S-" + LTrim(Str(pSid(0))) + "-" + LTrim(Str(pSiaByte(5)))
    '
    ' The rest of the SDDL form contains a list of sub authorities separated by
    ' "-"s.  The total number of these authorities can be obtained by
    ' calling the GetSidSubAuthorityCount.  The value returned is a pointer into the
    ' SID memory that contains the Sub Authority value, once again, this memory
    ' must be copied into something that VB knows how to manage.
    '
    ' Notice that only 1 byte is copied.  This is because the sub authority count
    ' is stored in a single byte ( see the SID srtructure definition above )
    '
    pSubAuthorityCount = GetSidSubAuthorityCount(pSid(0))
    CopyByValMemory bSubAuthorityCount, pSubAuthorityCount, 1
    '
    ' We can loop throught the sub authorities and convert
    ' their DWORD values to VB longs, then convert them to a
    ' string.
    ' The count is 0 based, so we start a 0 and goto the
    ' number of sub authorities - 1
    '
    For AuthCount = 0 To bSubAuthorityCount - 1
      pAuthority = GetSidSubAuthority(pSid(0), AuthCount)
      CopyByValMemory lAuthority, pAuthority, LenB(lAuthority)
      '
      ' VB does not have an unsigned type, the sub authority value
      ' could have the most significant bit set.  If it is set,
      ' the Str function will return a negative number.  Therefore
      ' we must account for this case by converting the value to
      ' a double then to its string form
      '
      ' Step 1: Test the bit if set, Do step 2 and 3 else put
      ' the value in the output string.
      ' Step 2: 1 is true, so, AND off all the bits save the most
      '   significant bit, place in a temp double variable
      ' Step 3: Add the most significant bit to the double variable ( 2^31)
      ' Output the string
      '
      ' Step 1:
      '
      dAuthority = lAuthority
      If ((lAuthority And &H80000000) <> 0) Then
         '
         ' Bit is set, Step 2:
         '
         dAuthority = lAuthority & &H7FFFFFFF
         '
         ' Step 3:
         '
         dAuthority = dAuthority + 2 ^ 31
      End If
      SDDL_SID = SDDL_SID + "-" + LTrim(Str(dAuthority))
    Next AuthCount
    '
    ' We are done, the SDDL_SID variable contains the SID in
    ' SDDL form,
    ' Return it...
    '
    Local_Convert_BIN_To_SDDL = SDDL_SID
End Function
'Private Function UserName() As String
'Dim RetVal As Long
'Dim Buffer As String
'         Buffer = String(50, 0)
'
'    RetVal = GetUserName(Buffer, 50)
'    UserName = Left(Buffer, InStr(Buffer, Chr(0)) - 1)
'
'End Function
''Get User Names
'Private Declare Function NetUserEnum Lib "netapi32" (ByVal servername As Long, ByVal level As Long, ByVal filter As Long, buf As Any, ByVal prefmaxlen As Long, entriesread As Long, totalentries As Long, resume_handle As Long) As Long
'Private Declare Function NetApiBufferFree Lib "netapi32.dll" (ByVal Ptr As Long) As Long
'Private Declare Sub RtlMoveMemory Lib "kernel32" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy&)
'Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
'Private Type NAME_INFO
'    name As Long
'End Type

'Get User Names
Private Function GetUserNames(ByVal Domain As String, ByRef Users() As String) As Boolean
'-----------------------------------------------------------------------
'Procedure    : frmMain.GetUserNames
'Author       : GWilmot
'Date Created : 04/12/2002
'-----------------------------------------------------------------------
'Purpose      : Returns a list of users for a given Domain
'Assumptions  :
'Inputs       : Domain - Normally the PDC
'               Users() - list of users
'Returns      : False if failed
'Effects      :
'Last Updated :
'-----------------------------------------------------------------------
Dim llReply As Long                     'Holds API Reply
Dim llEntriesRead As Long               'Total number of entries returned by API call
Dim llTotalEntries As Long              'Total number of entries to be recalled
Dim lhResume As Long                    'Handle to resume the call if llEntriesRead<>llTotalEntries
Dim llBuffer As Long                    'Structure Pointer
Dim llLevel As Long                     'Structure type to retrieve
Dim llPrefMaxLen As Long                'Max amount of data to return
Dim ltUserInfo As NAME_INFO     'Holds data returned
Dim i As Long                           'For Counter
Dim llUserCount As Long                 'Counts the found Users
Dim llFilter As Long                    'Can filter Users
'API return codes
Const SV_SUCCESS As Long = 0
Const SV_MORE_DATA As Long = 234&
Const MAX_PREFERRED_LENGTH As Long = -1
Const ST_NAME_INFO As Long = 0
Const FT_ALL As Long = 0
    
    On Error GoTo Catch
    'Defaults
    llLevel = ST_NAME_INFO      'Basic Structure
    llFilter = FT_ALL                   'No filtering of accounts
    llPrefMaxLen = MAX_PREFERRED_LENGTH 'No Limit on whot can be returned
    ReDim Users(0 To 0)                 'if Ubound(Users) = 0 then its empty
    
    Do
        'Call depends on whether we have a Domain name
        If Domain = vbNullString Then
            llReply = NetUserEnum(0&, llLevel, llFilter, llBuffer, llPrefMaxLen, _
                llEntriesRead, llTotalEntries, lhResume)
        Else
            llReply = NetUserEnum(StrPtr(Domain), llLevel, llFilter, llBuffer, llPrefMaxLen, _
                llEntriesRead, llTotalEntries, lhResume)
        End If
                
        'See if we succeeded
        If llReply = SV_SUCCESS Or llReply = SV_MORE_DATA Then
            
            'Iterate through all the returned Users
            For i = 0 To llEntriesRead - 1
                
                'Copy the data into the struture
                RtlMoveMemory ltUserInfo, ByVal llBuffer, Len(ltUserInfo)
                
                'Increment our User count & redim array
                llUserCount = llUserCount + 1
                If llUserCount = 1 Then
                    ReDim Users(1 To 1)
                Else
                    ReDim Preserve Users(1 To llUserCount)
                End If
                
                'OK get it to the array by taking the structure pointer
                'and getting the string of the name
                Users(llUserCount) = WinPointerToString(ltUserInfo.name)
                
                'Adjust the pointer to the next entry
                llBuffer = llBuffer + Len(ltUserInfo)
            Next i
        End If
        
        'See if we need to clear down the buffer
        If llBuffer Then NetApiBufferFree llBuffer
    
    'As we've set the maximum llPrefMaxLen = -1 then it SHOULD only require a single call plus
    Loop Until llReply <> SV_MORE_DATA

    'Only return true if we got any
    If UBound(Users) > 0 Then GetUserNames = True
        
Finally:
    'See if we need to clear down the buffer
    If llBuffer Then NetApiBufferFree llBuffer
    Exit Function
    
Catch:
    'Reports back to developer if in debugmode
    If nbDebugMode Then MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure GetUserNames of Form frmMain"
    Resume Finally
End Function
Private Function WinPointerToString(ByVal StringPtr As Long) As String
'-----------------------------------------------------------------------
'Procedure    : ICE_NetFunctions.WinPointerToString
'Author       : GWilmot
'Date Created : 07/12/2002
'-----------------------------------------------------------------------
'Purpose      : Returns the string associated with a pointer
'Assumptions  : Errors passed up to calling routine
'Inputs       : StringPtr - String Pointer in memory
'Returns      : The String
'Effects      :
'Last Updated :
'-----------------------------------------------------------------------

Dim labyteBuffer() As Byte     'Holds the data as a Byte Form
Dim llLength As Long           'Holds the amount of data

'*** Errors passed up to calling routine

    'If it ain't Zero
    If StringPtr Then
        'Get the amount of data
        llLength = lstrlenW(StringPtr) * 2
        'If it ain't Zero
        If llLength Then
            'Set the Buffer
            ReDim labyteBuffer(0 To (llLength - 1)) As Byte
            'Fill it
            RtlMoveMemory labyteBuffer(0), ByVal StringPtr, llLength
            'Set the return value
            WinPointerToString = labyteBuffer
        End If
    End If
End Function


